package org.dromara.workflow.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.workflow.domain.TActivity;
import org.dromara.workflow.domain.bo.TActivityBo;
import org.dromara.workflow.domain.vo.TActivityVo;
import org.dromara.workflow.mapper.TActivityMapper;
import org.dromara.workflow.service.ITActivityService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 活动Service业务层处理
 *
 * @author Lion Li
 * @date 2024-07-19
 */
@RequiredArgsConstructor
@Service
public class TActivityServiceImpl implements ITActivityService {

    private final TActivityMapper baseMapper;

    /**
     * 查询活动
     *
     * @param id 主键
     * @return 活动
     */
    @Override
    public TActivityVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询活动列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 活动分页列表
     */
    @Override
    public TableDataInfo<TActivityVo> queryPageList(TActivityBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TActivity> lqw = buildQueryWrapper(bo);
        Page<TActivityVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的活动列表
     *
     * @param bo 查询条件
     * @return 活动列表
     */
    @Override
    public List<TActivityVo> queryList(TActivityBo bo) {
        LambdaQueryWrapper<TActivity> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TActivity> buildQueryWrapper(TActivityBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TActivity> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getCreateTime() != null, TActivity::getCreateTime, bo.getCreateTime());
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), TActivity::getTitle, bo.getTitle());
        lqw.eq(bo.getStartTime() != null, TActivity::getStartTime, bo.getStartTime());
        lqw.eq(bo.getEndTime() != null, TActivity::getEndTime, bo.getEndTime());
        return lqw;
    }

    /**
     * 新增活动
     *
     * @param bo 活动
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TActivityBo bo) {
        TActivity add = MapstructUtils.convert(bo, TActivity.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改活动
     *
     * @param bo 活动
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TActivityBo bo) {
        TActivity update = MapstructUtils.convert(bo, TActivity.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TActivity entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除活动信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
